(function () {
    Reveal.addEventListener('ready', animationHandler);
    Reveal.addEventListener('slidechanged', animationHandler);

    function animationHandler(event) {
        if (event.previousSlide) {
            updateAnimationClassList(event.previousSlide, true);
        }
        updateAnimationClassList(event.currentSlide);
    }

    function updateAnimationClassList(slide, remove) {
        var e = slide.querySelectorAll("[data-animation]");
        Array.prototype.forEach.call(e, function (node) {
            var classes = node.getAttribute('data-animation').split(" ");
            var fn = remove ? node.classList.remove : node.classList.add;
            fn.apply(node.classList, classes);
        });
        var es = slide.querySelectorAll("[data-animation-sequence]");
        Array.prototype.forEach.call(es, function (node) {
            var animations = node.getAttribute('data-animation-sequence').split("->").reverse();
            if (remove) {
                animations.forEach(function (c) {
                    return node.classList.remove(c);
                });
                node.classList.remove("infinite")
            } else {
                function showNextAnimation(a, p) {
                    var v = a.pop();
                    if (v) {
                        node.classList.remove("animated", p);
                        node.classList.add(v);
                        node.classList.add("animated");
                        node.addEventListener('animationend', function () {
                            showNextAnimation(a, v);
                        })
                    } else
                        node.classList.add("infinite")

                }

                showNextAnimation(animations)

            }


        });
    }
})();
